/*  Canon Bubble Jet Print Filter.
 *  Copyright CANON INC. 2001
 *  All Rights Reserved.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * NOTE:
 *  - As a special exception, this program is permissible to link with the
 *    libraries released as the binary modules.
 *  - If you write modifications of your own for these programs, it is your
 *    choice whether to permit this exception to apply to your modifications.
 *    If you do not wish that, delete this exception.
 */

#ifndef	_GLOBALS
#define	_GLOBALS

#undef	GLOBAL
#ifdef	DEFINE_GLOBALS
#define	GLOBAL
#else
#define	GLOBAL	extern
#endif

/////////////////////////////////////////////////////////
// Initialized variables

#ifdef	DEFINE_GLOBALS

GLOBAL gchar* g_hostname = "localhost";

GLOBAL const gchar* g_quality_button_name[] =
{
	"quality_high_button",
	"quality_standard_button",
	"quality_draft_button",
	"quality_custom_button",
	NULL
};

GLOBAL const int g_mess_map[] = 
{
	CNCL_MESS_Q_MAP1,
	CNCL_MESS_Q_MAP2,
	CNCL_MESS_Q_MAP3,
	0
};

GLOBAL gboolean g_media_type_entry_changed = FALSE;
GLOBAL gboolean g_media_type_popwin_mapped = FALSE;

GLOBAL gboolean g_media_size_entry_changed = FALSE;
GLOBAL gboolean g_media_size_popwin_mapped = FALSE;

GLOBAL gboolean g_media_supply_entry_changed = FALSE;
GLOBAL gboolean g_media_supply_popwin_mapped = FALSE;

GLOBAL gboolean g_cartridge_type_entry_changed = FALSE;
GLOBAL gboolean g_cartridge_type_popwin_mapped = FALSE;

#else

GLOBAL gchar* g_hostname;

GLOBAL const gchar* g_quality_button_name[];
GLOBAL const int g_mess_map[];

GLOBAL gboolean g_media_type_entry_changed;
GLOBAL gboolean g_media_type_popwin_mapped;

GLOBAL gboolean g_media_size_entry_changed;
GLOBAL gboolean g_media_size_popwin_mapped;

GLOBAL gboolean g_media_supply_entry_changed;
GLOBAL gboolean g_media_supply_popwin_mapped;

GLOBAL gboolean g_cartridge_type_entry_changed;
GLOBAL gboolean g_cartridge_type_popwin_mapped;

#endif

/////////////////////////////////////////////////////////
// Non initialized variables

#ifdef	USE_LIB_GLADE
GLOBAL GladeXML* g_ui_xml;
#endif

GLOBAL gboolean g_unit_inch;

GLOBAL gchar* g_socketname;
GLOBAL gchar* g_model_name;
GLOBAL short g_model_id;
GLOBAL char g_window_title[64];

GLOBAL UIDialog* g_main_window;

GLOBAL UIDB g_uidb;

GLOBAL GdkFont* g_main_font;
GLOBAL KeyTextList* g_keytext_list;
GLOBAL char* g_bjlibdir;
GLOBAL gboolean	g_valid_signal;

GLOBAL UIVersionDialog* g_version_dialog;
GLOBAL UIQualityDialog* g_quality_dialog;
GLOBAL UIColorDialog* g_color_dialog;
GLOBAL UIUserSizeDialog* g_user_size_dialog;
GLOBAL UIMediaSizeDialog* g_mediasize_illegal_dialog;
GLOBAL UIMediaSizeDialog* g_mediasize_recommend_dialog;
GLOBAL UIMediaTypeDialog* g_mediatype_dialog;

GLOBAL CNCLPAPERSIZE g_bj_paper_size;
GLOBAL long g_user_paper_size[3];

#endif
